# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.41.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator
from synctera_client_ng.models.shipping import Shipping

class PhysicalCardAllOf(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    card_image_id: Optional[StrictStr] = Field(None, description="The ID of the custom card image used for this card")
    shipping: Optional[Shipping] = None
    form: Optional[StrictStr] = None
    __properties = ["card_image_id", "shipping", "form"]

    @validator('form')
    def form_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ('PHYSICAL'):
            raise ValueError("must validate the enum values ('PHYSICAL')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PhysicalCardAllOf:
        """Create an instance of PhysicalCardAllOf from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of shipping
        if self.shipping:
            _dict['shipping'] = self.shipping.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PhysicalCardAllOf:
        """Create an instance of PhysicalCardAllOf from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PhysicalCardAllOf.parse_obj(obj)

        _obj = PhysicalCardAllOf.parse_obj({
            "card_image_id": obj.get("card_image_id"),
            "shipping": Shipping.from_dict(obj.get("shipping")) if obj.get("shipping") is not None else None,
            "form": obj.get("form")
        })
        return _obj

