# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.41.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class RateDetails(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    accrual_period: StrictStr = Field(..., description="How often interest gets calculated against the balance. Note: although two options are displayed here, only DAILY is supported at the moment. ")
    rate: StrictInt = Field(..., description="Rate in basis points. E.g. 5 represents 0.05%")
    valid_from: date = Field(..., description="Rate effective start date. Inclusive.")
    valid_to: Optional[date] = Field(None, description="Rate effective end date. Exclusive.")
    __properties = ["accrual_period", "rate", "valid_from", "valid_to"]

    @validator('accrual_period')
    def accrual_period_validate_enum(cls, v):
        if v not in ('DAILY', 'MONTHLY'):
            raise ValueError("must validate the enum values ('DAILY', 'MONTHLY')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RateDetails:
        """Create an instance of RateDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RateDetails:
        """Create an instance of RateDetails from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return RateDetails.parse_obj(obj)

        _obj = RateDetails.parse_obj({
            "accrual_period": obj.get("accrual_period"),
            "rate": obj.get("rate"),
            "valid_from": obj.get("valid_from"),
            "valid_to": obj.get("valid_to")
        })
        return _obj

