# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.41.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from synctera_client_ng.models.spend_control_rolling_window_days import SpendControlRollingWindowDays
from typing import Any, List
from pydantic import StrictStr, Field

SPENDCONTROLTIMERANGE_ONE_OF_SCHEMAS = ["SpendControlRollingWindowDays"]

class SpendControlTimeRange(BaseModel):
    """
    The time range to which the spend control applies
    """
    # data type: SpendControlRollingWindowDays
    oneof_schema_1_validator: Optional[SpendControlRollingWindowDays] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(SPENDCONTROLTIMERANGE_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = cls()
        error_messages = []
        match = 0
        # validate data type: SpendControlRollingWindowDays
        if type(v) is not SpendControlRollingWindowDays:
            error_messages.append(f"Error! Input type `{type(v)}` is not `SpendControlRollingWindowDays`")
        else:
            match += 1

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SpendControlTimeRange with oneOf schemas: SpendControlRollingWindowDays. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SpendControlTimeRange with oneOf schemas: SpendControlRollingWindowDays. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> SpendControlTimeRange:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> SpendControlTimeRange:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        match = 0

        # deserialize data into SpendControlRollingWindowDays
        try:
            instance.actual_instance = SpendControlRollingWindowDays.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SpendControlTimeRange with oneOf schemas: SpendControlRollingWindowDays. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SpendControlTimeRange with oneOf schemas: SpendControlRollingWindowDays. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

